import Flutter
import Foundation

public class BarcodeHandler: NSObject, FlutterStreamHandler {
    private var eventSink: FlutterEventSink?
    private let eventChannel: FlutterEventChannel
    
    init(registrar: FlutterPluginRegistrar) {
        eventChannel = FlutterEventChannel(name: "consoledoctor.barcode_scanner.events", binaryMessenger: registrar.messenger())
        super.init()
        eventChannel.setStreamHandler(self)
    }
    
    func publishError(_ error: FlutterError) {
        DispatchQueue.main.async {
            self.eventSink?(error)
        }
    }
    
    func publishEvent(_ event: [String: Any?]) {
        DispatchQueue.main.async {
            self.eventSink?(event)
        }
    }
    
    public func onListen(withArguments arguments: Any?,
                         eventSink: @escaping FlutterEventSink) -> FlutterError? {
        self.eventSink = eventSink
        return nil
    }
    
    public func onCancel(withArguments arguments: Any?) -> FlutterError? {
        eventSink = nil
        return nil
    }
}
