import 'package:consoledoctor_barcode_scanner/src/objects/barcode.dart';
import 'package:consoledoctor_barcode_scanner/src/objects/barcode_capture.dart';

import 'objects/scan_result.dart';

abstract class BarcodeLookupHandler {
  Future<ScanResult> lookupBarcode(BarcodeCapture barcodes);
  Function(String message)? updateStatusMessageCallback;

  void updateStatusMessage(String message) {
    if (updateStatusMessageCallback != null) {
      updateStatusMessageCallback!(message);
    }
  }
}

abstract class SingleBarcodeLookupHandler extends BarcodeLookupHandler {
  @override
  Future<ScanResult> lookupBarcode(BarcodeCapture barcodes) {
    return _lookupBarcode(barcodes.barcodes.first);
  }

  Future<ScanResult> _lookupBarcode(Barcode barcode);
}
