/// The authorization state of the scanner.
enum BarcodeScannerAuthorizationState {
  /// The scanner has not yet requested the required permissions.
  undetermined(0),

  /// The scanner has the required permissions.
  authorized(1),

  /// The user denied the required permissions.
  denied(2);

  const BarcodeScannerAuthorizationState(this.rawValue);

  factory BarcodeScannerAuthorizationState.fromRawValue(int value) {
    switch (value) {
      case 0:
        return BarcodeScannerAuthorizationState.undetermined;
      case 1:
        return BarcodeScannerAuthorizationState.authorized;
      case 2:
        return BarcodeScannerAuthorizationState.denied;
      default:
        throw ArgumentError.value(value, 'value', 'Invalid raw value.');
    }
  }

  /// The raw value for the state.
  final int rawValue;
}
