import 'package:barcode/barcode.dart';
import 'package:consoledoctor_barcode_scanner/src/enums/barcode_format.dart';

extension BarcodeFormatExtensions on BarcodeFormat {
  BarcodeType asBarcodeType() {
    return switch(this) {
      BarcodeFormat.code128 => BarcodeType.Code128,
      BarcodeFormat.code39 => BarcodeType.Code39,
      BarcodeFormat.code93 => BarcodeType.Code93,
      BarcodeFormat.codabar => BarcodeType.Codabar,
      BarcodeFormat.dataMatrix => BarcodeType.DataMatrix,
      BarcodeFormat.ean13 => BarcodeType.CodeEAN13,
      BarcodeFormat.ean8 => BarcodeType.CodeEAN8,
      BarcodeFormat.itf => BarcodeType.Itf,
      BarcodeFormat.qrCode => BarcodeType.QrCode,
      BarcodeFormat.upcA => BarcodeType.CodeUPCA,
      BarcodeFormat.upcE => BarcodeType.CodeUPCE,
      BarcodeFormat.pdf417 => BarcodeType.PDF417,
      BarcodeFormat.aztec => BarcodeType.Aztec,
      _ => throw BarcodeException('Invalid or unmappable BarcodeFormat format: $name')
    };
  }
}