import 'dart:ui';

import 'package:consoledoctor_barcode_scanner/src/objects/barcode_capture.dart';

class ScanEventDispatcher {
  Future<void> Function(BarcodeCapture barcodes)? _onBarcodeDetected;
  VoidCallback? _onCloseRequested;

  void onBarcodeDetected(Future<void> Function(BarcodeCapture)? detectionFunc) {
    _onBarcodeDetected = detectionFunc;
  }

  void onCloseRequested(VoidCallback? onClose) {
    _onCloseRequested = onClose;
  }

  Future<void> barcodeDetected(BarcodeCapture barcodes) {
    return _onBarcodeDetected != null
        ? _onBarcodeDetected!(barcodes)
        : Future.value();
  }

  void close() {
    if (_onCloseRequested == null) return;
    _onCloseRequested!();
  }
}